# Class Finishings

java.lang.Object
javax.print.attribute.EnumSyntax
javax.print.attribute.standard.Finishings

All Implemented Interfaces:
  `Serializable, Cloneable, Attribute, DocAttribute, PrintJobAttribute, PrintRequestAttribute`

public class Finishings extends EnumSyntax implements DocAttribute, PrintRequestAttribute, PrintJobAttribute
Class `Finishings` is a printing attribute class, an enumeration, that identifies whether the printer applies a finishing operation of some kind of binding to each copy of each printed document in the job. For multidoc print jobs (jobs with multiple documents), the `MultipleDocumentHandling` attribute determines what constitutes a "copy" for purposes of finishing.

Standard Finishings values are:

- `NONE`
- `STAPLE`
- `EDGE_STITCH`
- `BIND`
- `SADDLE_STITCH`
- `COVER`

The following `Finishings` values are more specific; they indicate a corner or an edge as if the document were a portrait document:

- `STAPLE_TOP_LEFT`
- `EDGE_STITCH_LEFT`
- `STAPLE_DUAL_LEFT`
- `STAPLE_BOTTOM_LEFT`
- `EDGE_STITCH_TOP`
- `STAPLE_DUAL_TOP`
- `STAPLE_TOP_RIGHT`
- `EDGE_STITCH_RIGHT`
- `STAPLE_DUAL_RIGHT`
- `STAPLE_BOTTOM_RIGHT`
- `EDGE_STITCH_BOTTOM`
- `STAPLE_DUAL_BOTTOM`

The STAPLE_XXX values are specified with respect to the document as if the document were a portrait document. If the document is actually a landscape or a reverse-landscape document, the client supplies the appropriate transformed value. For example, to position a staple in the upper left hand corner of a landscape document when held for reading, the client supplies the `STAPLE_BOTTOM_LEFT` value (since landscape is defined as a +90 degree rotation from portrait, i.e., anti-clockwise). On the other hand, to position a staple in the upper left hand corner of a reverse-landscape document when held for reading, the client supplies the `STAPLE_TOP_RIGHT` value (since reverse-landscape is defined as a -90 degree rotation from portrait, i.e., clockwise).

The angle (vertical, horizontal, angled) of each staple with respect to the document depends on the implementation which may in turn depend on the value of the attribute.

The effect of a `Finishings` attribute on a multidoc print job (a job with multiple documents) depends on whether all the docs have the same binding specified or whether different docs have different bindings specified, and on the (perhaps defaulted) value of the `MultipleDocumentHandling` attribute.

- If all the docs have the same binding specified, then any value of `MultipleDocumentHandling` makes sense, and the printer's processing depends on the `MultipleDocumentHandling` value:
  - `SINGLE_DOCUMENT` -- All the input docs will be bound together as one output document with the specified binding.
  - `SINGLE_DOCUMENT_NEW_SHEET` -- All the input docs will be bound together as one output document with the specified binding, and the first impression of each input doc will always start on a new media sheet.
  - `SEPARATE_DOCUMENTS_UNCOLLATED_COPIES` -- Each input doc will be bound separately with the specified binding.
  - `SEPARATE_DOCUMENTS_COLLATED_COPIES` -- Each input doc will be bound separately with the specified binding.
- If different docs have different bindings specified, then only two values of `MultipleDocumentHandling` make sense, and the printer reports an error when the job is submitted if any other value is specified:
  - `SEPARATE_DOCUMENTS_UNCOLLATED_COPIES` -- Each input doc will be bound separately with its own specified binding.
  - `SEPARATE_DOCUMENTS_COLLATED_COPIES` -- Each input doc will be bound separately with its own specified binding.

IPP Compatibility: Class Finishings encapsulates some of the IPP enum values that can be included in an IPP "finishings" attribute, which is a set of enums. The category name returned by `getName()` is the IPP attribute name. The enumeration's integer value is the IPP enum value. The `toString()` method returns the IPP string representation of the attribute value. In IPP Finishings is a multi-value attribute, this API currently allows only one binding to be specified.

See Also:
  - Serialized Form

## Field Summary

Fields
Modifier and Type
Field
Description
`static final Finishings`
`BIND`
This value indicates that a binding is to be applied to the document; the type and placement of the binding is site-defined.
`static final Finishings`
`COVER`
This value is specified when it is desired to select a non-printed (or pre-printed) cover for the document.
`static final Finishings`
`EDGE_STITCH`
Bind the document(s) with one or more staples (wire stitches) along one edge.
`static final Finishings`
`EDGE_STITCH_BOTTOM`
Bind the document(s) with one or more staples (wire stitches) along the bottom edge.
`static final Finishings`
`EDGE_STITCH_LEFT`
Bind the document(s) with one or more staples (wire stitches) along the left edge.
`static final Finishings`
`EDGE_STITCH_RIGHT`
Bind the document(s) with one or more staples (wire stitches) along the right edge.
`static final Finishings`
`EDGE_STITCH_TOP`
Bind the document(s) with one or more staples (wire stitches) along the top edge.
`static final Finishings`
`NONE`
Perform no binding.
`static final Finishings`
`SADDLE_STITCH`
Bind the document(s) with one or more staples (wire stitches) along the middle fold.
`static final Finishings`
`STAPLE`
Bind the document(s) with one or more staples.
`static final Finishings`
`STAPLE_BOTTOM_LEFT`
Bind the document(s) with one or more staples in the bottom left corner.
`static final Finishings`
`STAPLE_BOTTOM_RIGHT`
Bind the document(s) with one or more staples in the bottom right corner.
`static final Finishings`
`STAPLE_DUAL_BOTTOM`
Bind the document(s) with two staples (wire stitches) along the bottom edge assuming a portrait document (see above).
`static final Finishings`
`STAPLE_DUAL_LEFT`
Bind the document(s) with two staples (wire stitches) along the left edge assuming a portrait document (see above).
`static final Finishings`
`STAPLE_DUAL_RIGHT`
Bind the document(s) with two staples (wire stitches) along the right edge assuming a portrait document (see above).
`static final Finishings`
`STAPLE_DUAL_TOP`
Bind the document(s) with two staples (wire stitches) along the top edge assuming a portrait document (see above).
`static final Finishings`
`STAPLE_TOP_LEFT`
Bind the document(s) with one or more staples in the top left corner.
`static final Finishings`
`STAPLE_TOP_RIGHT`
Bind the document(s) with one or more staples in the top right corner.

## Constructor Summary

Constructors
Modifier
Constructor
Description
`protected`
`Finishings(int value)`
Construct a new finishings binding enumeration value with the given integer value.

## Method Summary

Modifier and Type
Method
Description
`final Class<? extends Attribute>`
`getCategory()`
Get the printing attribute class which is to be used as the "category" for this printing attribute value.
`protected EnumSyntax[]`
`getEnumValueTable()`
Returns the enumeration value table for class `Finishings`.
`final String`
`getName()`
Get the name of the category of which this attribute value is an instance.
`protected int`
`getOffset()`
Returns the lowest integer value used by class `Finishings`.
`protected String[]`
`getStringTable()`
Returns the string table for class `Finishings`.

### Methods declared in class EnumSyntax

`clone, getValue, hashCode, readResolve, toString`
Modifier and Type
Method
Description
`Object`
`clone()`
Returns a clone of this enumeration value, which to preserve the semantics of enumeration values is the same object as this enumeration value.
`int`
`getValue()`
Returns this enumeration value's integer value.
`int`
`hashCode()`
Returns a hash code value for this enumeration value.
`protected Object`
`readResolve()`
During object input, convert this deserialized enumeration instance to the proper enumeration value defined in the enumeration attribute class.
`String`
`toString()`
Returns a string value corresponding to this enumeration value.

### Methods declared in class Object

`equals, finalize, getClass, notify, notifyAll, wait, wait, wait`
Modifier and Type
Method
Description
`boolean`
`equals(Object obj)`
Indicates whether some other object is "equal to" this one.
`protected void`
`finalize()`
Deprecated, for removal: This API element is subject to removal in a future version.
Finalization is deprecated and subject to removal in a future release.
`final Class<?>`
`getClass()`
Returns the runtime class of this `Object`.
`final void`
`notify()`
Wakes up a single thread that is waiting on this object's monitor.
`final void`
`notifyAll()`
Wakes up all threads that are waiting on this object's monitor.
`final void`
`wait()`
Causes the current thread to wait until it is awakened, typically by being notified or interrupted.
`final void`
`wait(long timeoutMillis)`
Causes the current thread to wait until it is awakened, typically by being notified or interrupted, or until a certain amount of real time has elapsed.
`final void`
`wait(long timeoutMillis, int nanos)`
Causes the current thread to wait until it is awakened, typically by being notified or interrupted, or until a certain amount of real time has elapsed.

## Field Details

### NONE

public static final Finishings NONE
Perform no binding.

### STAPLE

public static final Finishings STAPLE
Bind the document(s) with one or more staples. The exact number and placement of the staples is site-defined.

### COVER

public static final Finishings COVER
This value is specified when it is desired to select a non-printed (or pre-printed) cover for the document. This does not supplant the specification of a printed cover (on cover stock medium) by the document itself.

### BIND

public static final Finishings BIND
This value indicates that a binding is to be applied to the document; the type and placement of the binding is site-defined.

### SADDLE_STITCH

public static final Finishings SADDLE_STITCH
Bind the document(s) with one or more staples (wire stitches) along the middle fold. The exact number and placement of the staples and the middle fold is implementation- and/or site-defined.

### EDGE_STITCH

public static final Finishings EDGE_STITCH
Bind the document(s) with one or more staples (wire stitches) along one edge. The exact number and placement of the staples is implementation- and/or site- defined.

### STAPLE_TOP_LEFT

public static final Finishings STAPLE_TOP_LEFT
Bind the document(s) with one or more staples in the top left corner.

### STAPLE_BOTTOM_LEFT

public static final Finishings STAPLE_BOTTOM_LEFT
Bind the document(s) with one or more staples in the bottom left corner.

### STAPLE_TOP_RIGHT

public static final Finishings STAPLE_TOP_RIGHT
Bind the document(s) with one or more staples in the top right corner.

### STAPLE_BOTTOM_RIGHT

public static final Finishings STAPLE_BOTTOM_RIGHT
Bind the document(s) with one or more staples in the bottom right corner.

### EDGE_STITCH_LEFT

public static final Finishings EDGE_STITCH_LEFT
Bind the document(s) with one or more staples (wire stitches) along the left edge. The exact number and placement of the staples is implementation- and/or site-defined.

### EDGE_STITCH_TOP

public static final Finishings EDGE_STITCH_TOP
Bind the document(s) with one or more staples (wire stitches) along the top edge. The exact number and placement of the staples is implementation- and/or site-defined.

### EDGE_STITCH_RIGHT

public static final Finishings EDGE_STITCH_RIGHT
Bind the document(s) with one or more staples (wire stitches) along the right edge. The exact number and placement of the staples is implementation- and/or site-defined.

### EDGE_STITCH_BOTTOM

public static final Finishings EDGE_STITCH_BOTTOM
Bind the document(s) with one or more staples (wire stitches) along the bottom edge. The exact number and placement of the staples is implementation- and/or site-defined.

### STAPLE_DUAL_LEFT

public static final Finishings STAPLE_DUAL_LEFT
Bind the document(s) with two staples (wire stitches) along the left edge assuming a portrait document (see above).

### STAPLE_DUAL_TOP

public static final Finishings STAPLE_DUAL_TOP
Bind the document(s) with two staples (wire stitches) along the top edge assuming a portrait document (see above).

### STAPLE_DUAL_RIGHT

public static final Finishings STAPLE_DUAL_RIGHT
Bind the document(s) with two staples (wire stitches) along the right edge assuming a portrait document (see above).

### STAPLE_DUAL_BOTTOM

public static final Finishings STAPLE_DUAL_BOTTOM
Bind the document(s) with two staples (wire stitches) along the bottom edge assuming a portrait document (see above).

## Constructor Details

### Finishings

protected Finishings(int value)
Construct a new finishings binding enumeration value with the given integer value.

Parameters:
  `value` - Integer value

## Method Details

### getStringTable

protected String[] getStringTable()
Returns the string table for class `Finishings`.

Overrides:
  `getStringTable` in class `EnumSyntax`
Returns:
  the string table

### getEnumValueTable

protected EnumSyntax[] getEnumValueTable()
Returns the enumeration value table for class `Finishings`.

Overrides:
  `getEnumValueTable` in class `EnumSyntax`
Returns:
  the value table

### getOffset

protected int getOffset()
Returns the lowest integer value used by class `Finishings`.

Overrides:
  `getOffset` in class `EnumSyntax`
Returns:
  the offset of the lowest enumeration value

### getCategory

public final Class<? extends Attribute> getCategory()
Get the printing attribute class which is to be used as the "category" for this printing attribute value.

For class `Finishings` and any vendor-defined subclasses, the category is class `Finishings` itself.

Specified by:
  `getCategory` in interface `Attribute`
Returns:
  printing attribute class (category), an instance of class `java.lang.Class`

### getName

public final String getName()
Get the name of the category of which this attribute value is an instance.

For class `Finishings` and any vendor-defined subclasses, the category name is `"finishings"`.

Specified by:
  `getName` in interface `Attribute`
Returns:
  attribute category name